.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm

LOOP_COUNT	= 5000
RC	= 1000

TestNoFrameA	PROTO: DWORD, :DWORD, :DWORD
TestNoFrameB	PROTO: DWORD, :DWORD, :DWORD
TestWithFrame	PROTO: DWORD, :DWORD, :DWORD
TheOne	PROTO C :DWORD,:DWORD,:DWORD

argument macro num
EXITM @CatStr(<[esp+4+>,%(num*4),<]>)
endm


.code
start:
	mov esi, esp	; for debugging and testing, we check the stack
	REPEAT 3
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RC
		invoke TestNoFrameA, 1, 2, 3
		ENDM
	counter_end
	print str$(eax), 9, "millicycles for TestNoFrameA", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RC
		invoke TestNoFrameB, 1, 2, 3
		ENDM
	counter_end
	print str$(eax), 9, "millicycles for TestNoFrameB", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RC
		invoke TheOne, 1, 2, 3
		ENDM
	counter_end
	print str$(eax), 9, "millicycles for TheOne", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RC
		invoke TestWithFrame, 1, 2, 3
		ENDM
	counter_end
	print str$(eax), 9, "millicycles for TestWithFrame", 13, 10, 10
	ENDM

	invoke TestNoFrameA, 1, 2, 3
	print "Size no frame A: ", 9
	mov eax, TestNoFrameA_END
	sub eax, TestNoFrameA
	print str$(eax), 13, 10

	invoke TestNoFrameB, 1, 2, 3
	print "Size no frame B: ", 9
	mov eax, TestNoFrameB_END
	sub eax, TestNoFrameB
	print str$(eax), 13, 10

	invoke TheOne, 1, 2, 3
	print "Size TheOne:     ", 9
	mov eax, TheOne_END
	sub eax, TheOne
	print str$(eax), 13, 10

	invoke TestWithFrame, 1, 2, 3
	print "Size with frame: ", 9
	mov eax, TestWithFrame_END
	sub eax, TestWithFrame
	print str$(eax), 13, 10

	sub esi, esp
	.if !Zero?
		MsgBox 0, str$(esi), "Problem with stack", MB_OK
	.endif
	exit

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
TestNoFrameA proc arg1, arg2, arg3
  pop ecx	; pop ret address
  pop eax	; pop arg1
  pop edx	; pop arg2
  xchg ecx, [esp]	; exchange ret address with arg3
;  .if eax!=1 || edx!=2 || ecx!=3
;  	MsgBox 0, "Problem NA", "Hi", MB_OK
;  .endif
  ret
TestNoFrameA endp
TestNoFrameA_END:

TestNoFrameB proc arg1, arg2, arg3
  mov eax, [esp+4]
  mov edx, [esp+8]
  mov ecx, [esp+12]
;  .if eax!=1 || edx!=2 || ecx!=3
;  	MsgBox 0, "Problem NB", "Hi", MB_OK
;  .endif
  ret 12
TestNoFrameB endp
TestNoFrameB_END:

TheOne proc C arg1, arg2, arg3
	mov eax, argument(1)
	mov edx, argument(2)
	mov ecx, argument(3)
  ret
TheOne endp
TheOne_END:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
TestWithFrame proc arg1, arg2, arg3
  mov ecx, arg3
  mov edx, arg2
  mov eax, arg1
;  .if eax!=1 || edx!=2 || ecx!=3
;  	MsgBox 0, "Problem WF", "Hi", MB_OK
;  .endif
  ret
TestWithFrame endp
TestWithFrame_END:
end start

OPT_WAIT	1
OPT_Tmp2Asm	1
